"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _standard = _interopRequireDefault(require("standard"));

var _chalk = _interopRequireDefault(require("chalk"));

var _util = _interopRequireDefault(require("util"));

_standard.default.lintFiles = _util.default.promisify(_standard.default.lintFiles);
/**
 * Class that defines code style tasks
 */

var CodeStyle =
/*#__PURE__*/
function () {
  function CodeStyle() {
    (0, _classCallCheck2.default)(this, CodeStyle);
  }

  (0, _createClass2.default)(CodeStyle, [{
    key: "init",

    /**
     * Inits service
     */
    value: function init() {
      this._config = this._d.config.c.codeStyle;
      this._logger = this._d.logger.createLogger('CodeStyleTask');
    }
    /**
     * Returns code style task function
     * @return {Function} code style task function
     */

  }, {
    key: "_codeStyle",

    /**
     * Checks code style
     * @return {Promise<bool>} true if code style passes
     */
    value: function () {
      var _codeStyle2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var wrongCodeStyle, stat, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, file, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, message;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._logger.trace('Code style task started');

                wrongCodeStyle = false;
                _context.next = 4;
                return _standard.default.lintFiles(this._config.files);

              case 4:
                stat = _context.sent;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 8;
                _iterator = stat.results[Symbol.iterator]();

              case 10:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 35;
                  break;
                }

                file = _step.value;

                if (file.messages.length > 0) {
                  wrongCodeStyle = true;

                  this._logger.error(_chalk.default.underline(file.filePath));
                }

                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context.prev = 16;

                for (_iterator2 = file.messages[Symbol.iterator](); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  message = _step2.value;

                  this._logger.error("  ", _chalk.default.red(message.severity, ' '), "".concat(_chalk.default.blueBright(message.line), ":").concat(_chalk.default.white(message.column), "  "), _chalk.default.yellow(message.message, '-'), _chalk.default.cyan(message.ruleId));
                }

                _context.next = 24;
                break;

              case 20:
                _context.prev = 20;
                _context.t0 = _context["catch"](16);
                _didIteratorError2 = true;
                _iteratorError2 = _context.t0;

              case 24:
                _context.prev = 24;
                _context.prev = 25;

                if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                  _iterator2.return();
                }

              case 27:
                _context.prev = 27;

                if (!_didIteratorError2) {
                  _context.next = 30;
                  break;
                }

                throw _iteratorError2;

              case 30:
                return _context.finish(27);

              case 31:
                return _context.finish(24);

              case 32:
                _iteratorNormalCompletion = true;
                _context.next = 10;
                break;

              case 35:
                _context.next = 41;
                break;

              case 37:
                _context.prev = 37;
                _context.t1 = _context["catch"](8);
                _didIteratorError = true;
                _iteratorError = _context.t1;

              case 41:
                _context.prev = 41;
                _context.prev = 42;

                if (!_iteratorNormalCompletion && _iterator.return != null) {
                  _iterator.return();
                }

              case 44:
                _context.prev = 44;

                if (!_didIteratorError) {
                  _context.next = 47;
                  break;
                }

                throw _iteratorError;

              case 47:
                return _context.finish(44);

              case 48:
                return _context.finish(41);

              case 49:
                if (wrongCodeStyle) {
                  this._logger.error('Code style task failed');
                } else {
                  this._logger.info('Code style check passed successfully');
                }

                return _context.abrupt("return", !wrongCodeStyle);

              case 51:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[8, 37, 41, 49], [16, 20, 24, 32], [25,, 27, 31], [42,, 44, 48]]);
      }));

      function _codeStyle() {
        return _codeStyle2.apply(this, arguments);
      }

      return _codeStyle;
    }()
  }, {
    key: "codeStyle",
    get: function get() {
      return this._codeStyle.bind(this);
    }
  }]);
  return CodeStyle;
}();

exports.default = CodeStyle;