"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _chalk = _interopRequireDefault(require("chalk"));

var _gulpBabel = _interopRequireDefault(require("gulp-babel"));

var _gulpUglify = _interopRequireDefault(require("gulp-uglify"));

var _gulpGzip = _interopRequireDefault(require("gulp-gzip"));

var _gulpIf = _interopRequireDefault(require("gulp-if"));

var _through = _interopRequireDefault(require("through"));

var _lazypipe = _interopRequireDefault(require("lazypipe"));

var _gulpBro = _interopRequireDefault(require("gulp-bro"));

var _babelify = _interopRequireDefault(require("babelify"));

/**
 * Class that defines compile tasks
 */
var Compile =
/*#__PURE__*/
function () {
  function Compile() {
    (0, _classCallCheck2.default)(this, Compile);
  }

  (0, _createClass2.default)(Compile, [{
    key: "init",

    /**
     * Inits compile tasks
     * @param {Object} gulp gulp instance
     */
    value: function init(gulp) {
      this._gulp = gulp;
      this._config = this._d.config.c.compile;
      if (typeof this._config.steps === 'string') this._config.steps = this._config.presets[this._config.steps] || [];
      this._logger = this._d.logger.createLogger('CompileTask');
    }
    /**
     * Returns compile task function
     * @return {Function} compile task function
     */

  }, {
    key: "_compile",

    /**
     * Compiles an app according to steps in the config
     * @return {Promise<bool>} resolves with true if app is successfully compiled
     */
    value: function () {
      var _compile2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this = this;

        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step, _ret;

        return _regenerator.default.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this._logger.trace('Compile task started');

                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context2.prev = 4;
                _loop =
                /*#__PURE__*/
                _regenerator.default.mark(function _loop() {
                  var _step$value, index, _step$value$, name, src, transforms, dest;

                  return _regenerator.default.wrap(function _loop$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _step$value = (0, _slicedToArray2.default)(_step.value, 2), index = _step$value[0], _step$value$ = _step$value[1], name = _step$value$.name, src = _step$value$.src, transforms = _step$value$.transforms, dest = _step$value$.dest;

                          _this._logger.trace("Step ".concat(_chalk.default.yellow(index), " started ~ ").concat(_chalk.default.magenta(name)));

                          _context.prev = 2;
                          _context.next = 5;
                          return new Promise(function (resolve, reject) {
                            _this._gulp.src(src).pipe((0, _gulpIf.default)(transforms.length > 0, _this._transforms(transforms))).on('error', reject).pipe(_this._gulp.dest(dest)).on('error', reject).on('end', resolve);
                          });

                        case 5:
                          _this._logger.trace("Step ".concat(_chalk.default.yellow(index), " ").concat(_chalk.default.green('finished'), " ~ ").concat(_chalk.default.magenta(name)));

                          _context.next = 12;
                          break;

                        case 8:
                          _context.prev = 8;
                          _context.t0 = _context["catch"](2);

                          _this._logger.error("Step ".concat(_chalk.default.yellow(index), " ").concat(_chalk.default.red('failed with an error'), " ~ ").concat(_chalk.default.magenta(name)), _context.t0);

                          return _context.abrupt("return", {
                            v: false
                          });

                        case 12:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _loop, this, [[2, 8]]);
                });
                _iterator = this._config.steps.entries()[Symbol.iterator]();

              case 7:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context2.next = 15;
                  break;
                }

                return _context2.delegateYield(_loop(), "t0", 9);

              case 9:
                _ret = _context2.t0;

                if (!((0, _typeof2.default)(_ret) === "object")) {
                  _context2.next = 12;
                  break;
                }

                return _context2.abrupt("return", _ret.v);

              case 12:
                _iteratorNormalCompletion = true;
                _context2.next = 7;
                break;

              case 15:
                _context2.next = 21;
                break;

              case 17:
                _context2.prev = 17;
                _context2.t1 = _context2["catch"](4);
                _didIteratorError = true;
                _iteratorError = _context2.t1;

              case 21:
                _context2.prev = 21;
                _context2.prev = 22;

                if (!_iteratorNormalCompletion && _iterator.return != null) {
                  _iterator.return();
                }

              case 24:
                _context2.prev = 24;

                if (!_didIteratorError) {
                  _context2.next = 27;
                  break;
                }

                throw _iteratorError;

              case 27:
                return _context2.finish(24);

              case 28:
                return _context2.finish(21);

              case 29:
                this._logger.info('Compile task finished successfully');

                return _context2.abrupt("return", true);

              case 31:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee, this, [[4, 17, 21, 29], [22,, 24, 28]]);
      }));

      function _compile() {
        return _compile2.apply(this, arguments);
      }

      return _compile;
    }()
    /**
     * Creates transform channel with different pipes
     * @param {Array<string|Object>} transforms array with different transform options
     * @return {Object} transform channel (stream)
     */

  }, {
    key: "_transforms",
    value: function _transforms(transforms) {
      var _this2 = this;

      var transformsChannel = (0, _lazypipe.default)();
      var emptyChannel = (0, _through.default)();
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        var _loop2 = function _loop2() {
          var transform = _step2.value;
          var transformName = typeof transform === 'string' ? transform : transform.name;

          if (transformName === 'babel') {
            transformsChannel = transformsChannel.pipe(function () {
              return _this2._babelTransform();
            });

            _this2._logger.trace("Babel transform added");
          } else if (transformName === 'browserify') {
            transformsChannel = transformsChannel.pipe(function () {
              return _this2._browserifyTransform(transform);
            });

            _this2._logger.trace("Browserify transform added");
          } else if (transformName === 'uglify') {
            transformsChannel = transformsChannel.pipe(function () {
              return _this2._uglifyTransform();
            });

            _this2._logger.trace("Uglify transform added");
          } else if (transformName === 'gzip') {
            transformsChannel = transformsChannel.pipe(function () {
              return _this2._gzipTransform();
            });

            _this2._logger.trace("Gzip transform added");
          } else {
            throw new Error("There is no '".concat(transformName, "' transform"));
          }
        };

        for (var _iterator2 = transforms[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          _loop2();
        } // needed because lazypipe cannot create stream if it wasn't piped to anything

      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      transformsChannel = transformsChannel.pipe(function () {
        return emptyChannel;
      });
      return transformsChannel();
    }
    /**
     * Creates babel transform channel
     * @return {object} babel transform channel (stream)
     */

  }, {
    key: "_babelTransform",
    value: function _babelTransform() {
      return (0, _lazypipe.default)().pipe(function () {
        return (0, _gulpBabel.default)();
      })();
    }
    /**
     * Creates browserify transform channel
     * @param {string|Object} transform transform options
     * @return {Object} browserify transform channel (stream)
     */

  }, {
    key: "_browserifyTransform",
    value: function _browserifyTransform(transform) {
      var options = {
        transform: [],
        error: 'emit'
      };

      if ((0, _typeof2.default)(transform.browserifyTransforms) === 'object') {
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = transform.browserifyTransforms[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var browserifyTransform = _step3.value;
            if (browserifyTransform === 'babelify') options.transform.push(_babelify.default);
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      }

      return (0, _lazypipe.default)().pipe(function () {
        return (0, _gulpBro.default)(options);
      })();
    }
    /**
     * Creates uglify transform channel
     * @return {object} uglify transform channel (stream)
     */

  }, {
    key: "_uglifyTransform",
    value: function _uglifyTransform() {
      return (0, _lazypipe.default)().pipe(function () {
        return (0, _gulpUglify.default)();
      })();
    }
    /**
     * Creates gzip transform channel
     * @return {object} gzip transform channel (stream)
     */

  }, {
    key: "_gzipTransform",
    value: function _gzipTransform() {
      return (0, _lazypipe.default)().pipe(function () {
        return (0, _gulpGzip.default)();
      })();
    }
  }, {
    key: "compile",
    get: function get() {
      return this._compile.bind(this);
    }
  }]);
  return Compile;
}();

exports.default = Compile;