"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _chalk = _interopRequireDefault(require("chalk"));

/**
 * Class that defines default task that outputs defined gulp tasks
 */
var Default =
/*#__PURE__*/
function () {
  function Default() {
    (0, _classCallCheck2.default)(this, Default);
  }

  (0, _createClass2.default)(Default, [{
    key: "_default",

    /**
     * Outputs all tasks descriptions
     */
    value: function () {
      var _default2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                console.log("This build has this gulp tasks:");

                this._outputDescription(['test'], 'task runs clean, code-style, jsdoc and unit-tests-coverage tasks', ['plain']);

                this._outputDescription(['code-style', 'cs'], 'task checks JavaScript code with the standard syntax on files with .js extension');

                this._outputDescription(['unit-tests', 'ut'], 'task runs tests on files with .test.js endings using mocha');

                this._outputDescription(['unit-tests-coverage', 'utc'], 'task validates tests coverage on files with .test.js endings using nyc');

                this._outputDescription(['swagger', 'sg'], 'task validates swagger documentation');

                this._outputDescription(['jsdoc', 'j'], 'task generates and tests js docs with esdoc npm module');

                this._outputDescription(['compile', 'c'], 'task compiles an app by steps defined in config');

                this._outputDescription(['dist', 'd'], 'task executes compile task and then copies source to destination');

                this._outputDescription(['runner', 'r'], 'task executes steps defined in config. It can run livereload server, command or other task');

                this._outputDescription(['explore', 'e'], 'task opens in the browser and outputs to the console paths(folder/file) specified in config', ['plain']);

                this._outputDescription(['clean'], 'task removes all paths(folder/file) specified in config', ['plain']);

                return _context.abrupt("return", true);

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _default() {
        return _default2.apply(this, arguments);
      }

      return _default;
    }()
    /**
     * Outputs tasks description
     * @param {string} taskNames tasks names
     * @param {string} description tasks description
     * @param {Array<string>} [types=['plain','fail-safe','watcher']] types of gulp tasks, that exists
     * @return {string} outputs description
     */

  }, {
    key: "_outputDescription",
    value: function _outputDescription(taskNames, description) {
      var types = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ['plain', 'fail-safe', 'watcher'];
      var mainName = taskNames[0];

      if (types.includes('plain')) {
        var names = "[".concat(taskNames.join(', '), "]");
        console.log("  ".concat(_chalk.default.blueBright(names), " - ").concat(description));
      }

      if (types.includes('fail-safe')) {
        var _names = "[".concat(taskNames.map(function (n) {
          return "".concat(n, "-fail-safe");
        }).join(', '), "]");

        console.log(_chalk.default.gray("  ".concat(_names, " - task same as ").concat(mainName, ", but it doesn't exit with an error code, in case of any error")));
      }

      if (types.includes('watcher')) {
        var _names2 = "[".concat(taskNames.map(function (n) {
          return "".concat(n, "-watch");
        }).join(', '), "]");

        console.log(_chalk.default.gray("  ".concat(_names2, " - task watches files and executes ").concat(mainName, "-fail-safe task")));
      }
    }
  }, {
    key: "default",

    /**
     * Returns default task function
     * @return {Function} default task function
     */
    get: function get() {
      return this._default.bind(this);
    }
  }]);
  return Default;
}();

exports.default = Default;