"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

/**
 * Class that defines distribution tasks
 */
var Dist =
/*#__PURE__*/
function () {
  function Dist() {
    (0, _classCallCheck2.default)(this, Dist);
  }

  (0, _createClass2.default)(Dist, [{
    key: "init",

    /**
     * Inits dist tasks
     */
    value: function init() {
      this._config = this._d.config.c.dist;
      this._logger = this._d.logger.createLogger('DistTask');
    }
    /**
     * Returns distribution task function
     * @return {Function} distribution task function
     */

  }, {
    key: "_dist",

    /**
     * Copies compiled files to distribution folder
     * @return {Promise<bool>} relosves with true when files are copied
     */
    value: function () {
      var _dist2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;

                this._logger.trace('Dist task started');

                _context.next = 4;
                return this._d.compile.compile();

              case 4:
                this._logger.trace("Moving files from ".concat(this._config.src, " to ").concat(this._config.dest));

                _context.next = 7;
                return this._d.fm.copy(this._config.src, this._config.dest);

              case 7:
                this._logger.info('Dist task finished successfully');

                return _context.abrupt("return", true);

              case 11:
                _context.prev = 11;
                _context.t0 = _context["catch"](0);

                this._logger.error('Dist task failed', _context.t0);

                return _context.abrupt("return", false);

              case 15:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 11]]);
      }));

      function _dist() {
        return _dist2.apply(this, arguments);
      }

      return _dist;
    }()
  }, {
    key: "dist",
    get: function get() {
      return this._dist.bind(this);
    }
  }]);
  return Dist;
}();

exports.default = Dist;