"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _path = _interopRequireDefault(require("path"));

var _opn = _interopRequireDefault(require("opn"));

/**
 * Class that defines explore tasks
 */
var Explore =
/*#__PURE__*/
function () {
  function Explore() {
    (0, _classCallCheck2.default)(this, Explore);
  }

  (0, _createClass2.default)(Explore, [{
    key: "init",

    /**
     * Inits service
     */
    value: function init() {
      this._config = this._d.config.c.explore;
      this._logger = this._d.logger.createLogger('ExploreTask');
    }
    /**
     * Returns explore task function
     * @return {Function} explore task function
     */

  }, {
    key: "_explore",

    /**
     * Opens paths in default broswer
     */
    value: function () {
      var _explore2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var paths, succeeded, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, p, absolutePath, url;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._logger.trace('Explore task started');

                paths = this._config.paths || [];
                succeeded = true;
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 6;
                _iterator = paths[Symbol.iterator]();

              case 8:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 25;
                  break;
                }

                p = _step.value;
                absolutePath = _path.default.resolve(process.cwd(), p);
                url = "file://".concat(absolutePath);
                _context.prev = 12;
                _context.next = 15;
                return (0, _opn.default)(url);

              case 15:
                this._logger.info("Path opened: ".concat(url));

                _context.next = 22;
                break;

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](12);

                this._logger.error("Cannot open the path: ".concat(url));

                succeeded = false;

              case 22:
                _iteratorNormalCompletion = true;
                _context.next = 8;
                break;

              case 25:
                _context.next = 31;
                break;

              case 27:
                _context.prev = 27;
                _context.t1 = _context["catch"](6);
                _didIteratorError = true;
                _iteratorError = _context.t1;

              case 31:
                _context.prev = 31;
                _context.prev = 32;

                if (!_iteratorNormalCompletion && _iterator.return != null) {
                  _iterator.return();
                }

              case 34:
                _context.prev = 34;

                if (!_didIteratorError) {
                  _context.next = 37;
                  break;
                }

                throw _iteratorError;

              case 37:
                return _context.finish(34);

              case 38:
                return _context.finish(31);

              case 39:
                if (succeeded) {
                  this._logger.info('Explore task finished successfully');
                }

                return _context.abrupt("return", succeeded);

              case 41:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[6, 27, 31, 39], [12, 18], [32,, 34, 38]]);
      }));

      function _explore() {
        return _explore2.apply(this, arguments);
      }

      return _explore;
    }()
  }, {
    key: "explore",
    get: function get() {
      return this._explore.bind(this);
    }
  }]);
  return Explore;
}();

exports.default = Explore;