"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _gulpMocha = _interopRequireDefault(require("gulp-mocha"));

var _glob = _interopRequireDefault(require("glob"));

var _util = _interopRequireDefault(require("util"));

var globPromisified = _util.default.promisify(_glob.default);
/**
 * Class that defines unit tests tasks
 */


var UnitTests =
/*#__PURE__*/
function () {
  function UnitTests() {
    (0, _classCallCheck2.default)(this, UnitTests);
  }

  (0, _createClass2.default)(UnitTests, [{
    key: "init",

    /**
     * Inits unit tests tasks
     * @param {Object} gulp gulp instance
     */
    value: function init(gulp) {
      this._gulp = gulp;
      this._config = this._d.config.c.unitTests;
      this._logger = this._d.logger.createLogger('UnitTestsTask');
    }
    /**
     * Returns unit tests task function
     * @return {Function} unit tests task function
     */

  }, {
    key: "_unitTests",

    /**
     * Runs unit tests with mocha
     * @return {Promise<bool>} true if tests passed
     */
    value: function () {
      var _unitTests2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this = this;

        var files;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return globPromisified(this._config.files);

              case 2:
                files = _context.sent;

                if (!(files.length === 0)) {
                  _context.next = 6;
                  break;
                }

                this._logger.info('No tests found. Unit tests finished successfully');

                return _context.abrupt("return", true);

              case 6:
                return _context.abrupt("return", new Promise(function (resolve) {
                  _this._gulp.src(files, {
                    read: false
                  }).pipe((0, _gulpMocha.default)({
                    require: '@babel/register'
                  })).once('error', function (err) {
                    _this._logger.error('Unit tests failed with an error:', err.message);

                    resolve(false);
                  }).once('_result', function () {
                    _this._logger.info('Unit tests finished successfully');

                    resolve(true);
                  });
                }));

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _unitTests() {
        return _unitTests2.apply(this, arguments);
      }

      return _unitTests;
    }()
  }, {
    key: "unitTests",
    get: function get() {
      return this._unitTests.bind(this);
    }
  }]);
  return UnitTests;
}();

exports.default = UnitTests;