"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _fsExtra = _interopRequireDefault(require("fs-extra"));

/**
 * Class that defines methods for files management
 */
var FilesManagement =
/*#__PURE__*/
function () {
  function FilesManagement() {
    (0, _classCallCheck2.default)(this, FilesManagement);
  }

  (0, _createClass2.default)(FilesManagement, [{
    key: "remove",

    /**
     * Removes files/folders
     * @param {Array<String>} paths array of paths (files/folders) that would be removed
     * @return {Promise} resolves when all paths removed
     */
    value: function () {
      var _remove = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(paths) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", Promise.all(paths.map(function (p) {
                  return _fsExtra.default.remove(p);
                })));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function remove(_x) {
        return _remove.apply(this, arguments);
      }

      return remove;
    }()
    /**
     * Copies file/folder from source to destination
     * @param {string} src source folder/file
     * @param {string} dest destination folder/file
     * @return {Promise} resolves when folder/file are copied
     */

  }, {
    key: "copy",
    value: function () {
      var _copy = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(src, dest) {
        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _fsExtra.default.remove(dest);

              case 2:
                _context2.next = 4;
                return _fsExtra.default.copy(src, dest);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function copy(_x2, _x3) {
        return _copy.apply(this, arguments);
      }

      return copy;
    }()
  }]);
  return FilesManagement;
}();

exports.default = FilesManagement;